#include <stdio.h>
#include <stdlib.h>
#include "blz.h"

int freadwhole(char *name, uint8_t **buf) {
	FILE *fp = 0;
	size_t fl = 0;
	uint8_t *fc = 0;
	fp = fopen(name, "rb");
	if (!fp) return 0;
	fseek(fp, 0, SEEK_END);
	fl = ftell(fp);
	fseek(fp, 0, SEEK_SET);
	fc = (uint8_t*)malloc(fl);
	fread(fc, 1, fl, fp);
	fclose(fp);
	*buf = fc;
	return fl;
}

int main(int argc, char** argv) {
	uint8_t *obuf = 0, *nbuf = 0;
	int olen = 0, nlen = 0, i = 0;
	FILE *fp = 0;
	printf("[INFO]Backward LZ77 Compressor, hard-coded version.\n");
	if (argc < 1) {
		printf("[HELP]This is intended for code.bin compression. It doesn't know if that's already compressed.\n");
		printf("[HELP]Please pass the files' name as arguements. Compressed file would overwrite the original.\n");
		exit(0);
	}
	for (i = 1; i < argc; i ++) {
		printf("[INFO]Compressing file %s..", argv[i]);
		olen = freadwhole(argv[i], &obuf);
		if ((!obuf)||(!olen)) {
			printf("ERR: File inaccessible? Read failed. Or just missing.\n");
			printf("[ERR:]argv[%d]=%s, nbuf=%08X, olen=%d.\n",i,argv[i],obuf,olen);
			continue;
		}
		nbuf = BLZ_Code(obuf, olen, &nlen, 0);
		fp = fopen(argv[i], "wb");
		if (fwrite(nbuf, 1, nlen, fp) != nlen)
			printf("ERR: File inaccessible? Write failed.\n");
		else 
			printf("DONE File compressed and overwritten.\n");
		fclose(fp);
		free(obuf);
		free(nbuf);
	}
	printf("[INFO]Compression jobs are done. Congratulations.\n");
	return 0;
}
